#
# spec file for package glslang
#
# Copyright (c) 2016 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%define version_unconverted 2.3.g537

Name:           glslang
Version:        2.3.g537
Release:        3.14
Summary:        OpenGL and OpenGL ES shader front end and validator
License:        BSD-3-Clause
Group:          Development/Libraries/C and C++
Url:            https://www.khronos.org/opengles/sdk/tools/Reference-Compiler/

Source:         %name-%version.tar.xz
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  bison
BuildRequires:  cmake >= 2.8
BuildRequires:  gcc-c++

%description
glslang is the official reference compiler front end for the OpenGL
ES and OpenGL shading languages. It implements a strict
interpretation of the specifications for these languages.

%package devel
Summary:        OpenGL and OpenGL ES shader front end and validator
Group:          Development/Libraries/C and C++

%description devel
glslang is the official reference compiler front end for the OpenGL
ES and OpenGL shading languages. It implements a strict
interpretation of the specifications for these languages.

spirv-remap is a utility to improve compression of SPIR-V binary
files via entropy reduction, plus optional stripping of debug
information and load/store optimization. It transforms SPIR-V to
SPIR-V, remapping IDs. The resulting modules have an increased ID
range (IDs are not as tightly packed around zero), but will compress
better when multiple modules are compressed together, since
compressor's dictionary can find better cross module commonality.

%prep
%setup -q

%build
%cmake
make %{?_smp_mflags}

%install
b="%buildroot"
%cmake_install
# So much fail in this source package..
if test "%_lib" != lib; then
	mkdir -p "$b/%_libdir"
	mv "$b/%_prefix/lib"/*.a "$b/%_libdir/"
fi
mkdir -p "$b/%_includedir"
cp -a SPIRV glslang "$b/%_includedir/"
find "$b/%_includedir/" -type f ! -iname "*.h" -a ! -iname "*.hpp" -print -delete
ln -s SPIRV/spirv.hpp "$b/%_includedir/"
find "$b/%_includedir/" -type f -exec chmod a-x "{}" "+"
cp build/StandAlone/libglslang-default-resource-limits.so "$b/%_libdir/"

%files devel
%defattr(-,root,root)
%_bindir/gls*
%_bindir/spirv*
%_libdir/*.a
%_libdir/*resource*.so
%_includedir/*

%changelog
* Sun Jun 12 2016 jengelh@inai.de
- Update to 2.3g537
  * HLSL: Implement proper nesting of symbol-table scopes and
  identifier searching.
  * HLSL: Add all int/float/bool/uint matrix types, void for
  functions, and a few others.
  * Types: Add an isOpaque() helper
  * remapper: do not eliminate interface variables in dce by default
  * Initial implementation of direct-mapped subset of HLSL intrinsics
  with type subset.
  * SPV: Don't shadow sampler parameters when performing function calls
  * Check for linking multiple ES shaders to the same stage
  * Vulkan: Finish semantics for what creates spec-const-semantics.
  * HLSL: Add more matrix types to the grammar.
  * Full stack: distinguish between a scalar and a vector of size 1.
  * SPV: Don't emit memory barrier for ESSL barrier(), but still do
  for GLSL barrier().
  * Add support for querying vertex attributes in reflection API
  * SPV: Don't add clip/cull distance capabilities unless used.
  * Tests: Add a set of gtest-file-based HLSL tests.
  * SPV: Handle matrix's OpFConvert vector by vector.
  * HLSL: Add function call syntax and AST building.
  * SPV: Add capability ImageGatherExtended if necessary.
  * SPIR-V do not decorate: members of plain structs with location;
  non-top level members with interp.
* Tue Apr 26 2016 jengelh@inai.de
- Update to 2.3.g401
  * Fix compile error involving std::isinf
- Drop badcode.diff (merged upstream)
* Wed Feb 17 2016 jengelh@inai.de
- Initial package (version 2.3.g244) for build.opensuse.org
- Add badcode.diff
